//+------------------------------------------------------------------+
//|                                     ind_DivDirectPriceRSI_v1.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
#property indicator_color3 DeepSkyBlue
#property indicator_color4 Red

#property indicator_width3 1
#property indicator_width4 1

//---- input parameters
extern int PriceMAPeriod=1;
extern int PriceMAMethod=0;
extern int PriceMAPrice=0;
extern int FPeriod=14;
extern int FMethod=0; // 0-SMA, 1-EMA, 2-SMMA, 4-LWMA
extern int FPrice=0; // 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted




extern int DiferDistance=1; 
extern int DiferSmPeriod=3;
extern int DiferSmMethod=0;

//---- buffers
double Buy[];
double Sell[];
double BBuy[];
double BSell[];
double PriceDifer[];
double RSIDifer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   IndicatorBuffers(6);

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,225);
   SetIndexBuffer(0,Buy);
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,226);
   SetIndexBuffer(1,Sell);
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,233);
   SetIndexBuffer(2,BBuy);
   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,234);
   SetIndexBuffer(3,BSell);
   
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,RSIDifer);
   
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,PriceDifer);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               PriceDifer[i]=iMA(NULL,0,PriceMAPeriod,0,PriceMAMethod,PriceMAPrice,i)-iMA(NULL,0,PriceMAPeriod,0,PriceMAMethod,PriceMAPrice,i+DiferDistance);
               RSIDifer[i]=iForce(NULL,0,FPeriod,FMethod,FPrice,i)-iForce(NULL,0,FPeriod,FMethod,FPrice,i+DiferDistance);
            }
         static int Last;
            for(i=limit-1;i>=0;i--){ 
               Buy[i]=EMPTY_VALUE;
               Sell[i]=EMPTY_VALUE;    
               BBuy[i]=EMPTY_VALUE;
               BSell[i]=EMPTY_VALUE;   
               
               double PriceDiferSm=iMAOnArray(PriceDifer,0,DiferSmPeriod,0,DiferSmMethod,i);
               double RSIDiferSm=iMAOnArray(RSIDifer,0,DiferSmPeriod,0,DiferSmMethod,i);
               
                  if(Buy[i+1]!=EMPTY_VALUE){
                     Last=1;
                  }
                  if(Sell[i+1]!=EMPTY_VALUE){
                     Last=-1;
                  }                  
               
                  if(PriceDiferSm>0 && RSIDiferSm<0){
                     Buy[i]=Low[i]-Point*5;
                        if(Last==-1){
                           BBuy[i]=Low[i]-Point*5;
                        }
                  }               
                  if(PriceDiferSm<0 && RSIDiferSm>0){
                     Sell[i]=High[i]+Point*5;
                        if(Last==1){
                           BSell[i]=High[i]+Point*5;
                        }
                  }                    
            }           
            
            
   return(0);
  }
//+------------------------------------------------------------------+